// a simple class for String trees.

class StrTree  {
     
    // We do not provide a way to set the String in an existing node; that's a bad idea.
    class treenode {
	private String data_;
	private treenode left_, right_;
	public treenode(String d, treenode l, treenode r) {
		data_ = d; left_ = l; right_ = r;
	}
	public String data() {return data_;}
	public treenode left()  {return left_;}
	public treenode right() {return right_;}
	public void setleft  (treenode t) {left_ = t;}
	public void setright (treenode t) {right_ = t;}
    }

    private treenode root_ = null;

    public void inTraverse() {inTraverse(root_, 0);}

    private void inTraverse(treenode p, int depth) {
    	int indent = 4;
    	if (p==null) return;
    	inTraverse(p.left(), depth+1);
    	String prefix = "";
    	for (int i=0; i<depth*indent; i++) prefix += ' ';
    	System.out.printf("%s%s%n", prefix, p.data());
    	inTraverse(p.right(), depth+1);
    }


    // must not be called with val == null
    public void insert(String val) {
	if (root_ == null) {
		root_ = new treenode(val, null, null);
		return;
	} else {
		rinsert(val, root_);
	}
    }

    // recursive insert: does not get called with t==null
    private void rinsert(String val, treenode t) {
	int comp = val.compareTo(t.data()); // = 0 if Strings ==, <0 if val<t.data, etc
	if (comp == 0 ) return;	// This is where you would update the count
	if (comp < 0) {		// val < t.data()
	    if (t.left() == null) {
		    t.setleft(new treenode(val, null, null));
	    } else {
		    rinsert(val, t.left());
	    }
	} else { // val > t.data()
	    if (t.right() == null) {
		    t.setright(new treenode(val, null, null));
	    } else {
		    rinsert(val, t.right());
	    }
	}
    }
}